/// <reference types="codemirror" />
/// <reference types="@types/codemirror/codemirror-showhint" />
import * as lsProtocol from 'vscode-languageserver-protocol';
import { IEditorAdapter, ILspConnection, IPosition, ITextEditorOptions, ITokenInfo } from './types';
declare class CodeMirrorAdapter extends IEditorAdapter<CodeMirror.Editor> {
    options: ITextEditorOptions;
    editor: CodeMirror.Editor;
    connection: ILspConnection;
    private hoverMarker;
    private signatureWidget;
    private token;
    private markedDiagnostics;
    private highlightMarkers;
    private hoverCharacter;
    private debouncedGetHover;
    constructor(connection: ILspConnection, options: ITextEditorOptions, editor: CodeMirror.Editor);
    handleMouseOver(): void;
    handleChange(cm: CodeMirror.Editor, change: CodeMirror.EditorChange): void;
    handleHover(response: lsProtocol.Hover): void;
    handleHighlight(items: lsProtocol.DocumentHighlight[]): void;
    handleCompletion(completions: lsProtocol.CompletionItem[]): void;
    handleDiagnostic(response: lsProtocol.PublishDiagnosticsParams): void;
    handleSignature(result: lsProtocol.SignatureHelp): void;
    _getTokenEndingAtPosition(code: string, location: IPosition, splitCharacters: string[]): ITokenInfo;
    private _getFilteredCompletions;
    private _removeSignatureWidget;
}
export default CodeMirrorAdapter;
